VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   206
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.ListBox List1 
      Height          =   2010
      ItemData        =   "Form1.frx":0000
      Left            =   1320
      List            =   "Form1.frx":0016
      TabIndex        =   0
      Top             =   480
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  Private Type SIZE
    cx As Long
    cy As Long
  End Type


  Private iLastIndex As Integer
  Private ttToolTip As clsToolTip


  Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Dst As Any, Src As Any, ByVal sz As Long)
  Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long
  Private Declare Function GetTextExtentPoint32 Lib "gdi32.dll" Alias "GetTextExtentPoint32A" (ByVal hDC As Long, ByVal lpsz As String, ByVal cbString As Long, ByRef lpSize As SIZE) As Long
  Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, rc As RECT) As Long
  Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
  Private Declare Function ReleaseCapture Lib "user32.dll" () As Long
  Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hDC As Long) As Long
  Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long
  Private Declare Function SendMessageAsLong Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Private Declare Function SendMessageAsString Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
  Private Declare Function SetCapture Lib "user32.dll" (ByVal hWnd As Long) As Long


Private Sub Form_Initialize()
  InitCommonControls
End Sub

Private Sub Form_Load()
  iLastIndex = -1
  Set ttToolTip = New clsToolTip
  With ttToolTip
    .Unicode = False
    .Create Me.hWnd
    .Activate
    .AddTool List1.hWnd, "", , , False
  End With
End Sub

Private Sub Form_Terminate()
  Set ttToolTip = Nothing
End Sub

Private Sub List1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Const LB_ITEMFROMPOINT = &H1A9
  Dim index As Long
  Dim insideClientArea As Boolean
  Dim pxX As Integer
  Dim pxY As Integer
  Dim tmp As Long

  pxX = Me.ScaleX(X, ScaleModeConstants.vbTwips, ScaleModeConstants.vbPixels)
  pxY = Me.ScaleY(Y, ScaleModeConstants.vbTwips, ScaleModeConstants.vbPixels)
  tmp = SendMessageAsLong(List1.hWnd, LB_ITEMFROMPOINT, 0, MakeDWord(CInt(pxX), CInt(pxY)))
  insideClientArea = (RShiftDWord(tmp, 16) = 0)
  index = tmp And &HFFFF&

  If (Not insideClientArea) Or (index = -1) Then
    ReleaseCapture
    UpdateToolTip -1
  Else
    SetCapture List1.hWnd
    UpdateToolTip index
  End If
End Sub


' merges <Lo> and <Hi> to a 32 bit number
Private Function MakeDWord(ByVal Lo As Integer, ByVal Hi As Integer) As Long
  Dim ret As Long

  CopyMemory ByVal VarPtr(ret), ByVal VarPtr(Lo), LenB(Lo)
  CopyMemory ByVal VarPtr(ret) + LenB(Lo), ByVal VarPtr(Hi), LenB(Hi)

  MakeDWord = ret
End Function

' cuts <txt> at the first occurance of Chr(0)
Private Function removeNull(ByVal txt As String) As String
  Dim pos As Integer

  pos = InStr(txt, Chr(0))
  If pos Then txt = Left(txt, pos - 1)
  removeNull = txt
End Function

Private Function RShiftDWord(ByVal DWord As Long, ByVal Bytes As Integer) As Long
  RShiftDWord = DWord \ (2 ^ Bytes)
End Function

Private Sub UpdateToolTip(ByVal index As Integer)
  Const LB_GETTEXT = &H189
  Const LB_GETTEXTLEN = &H18A
  Const WM_GETFONT = &H31
  Dim hDC As Long
  Dim hFont As Long
  Dim hPrevFont As Long
  Dim rcWnd As RECT
  Dim s As String
  Dim sLen As Long
  Dim sz As SIZE

  If index = -1 Then
    ' remove tooltip
    ttToolTip.Text(List1.hWnd) = ""
    ttToolTip.Hide List1.hWnd
  ElseIf iLastIndex <> index Then
    ' get the item's text...
    sLen = SendMessageAsLong(List1.hWnd, LB_GETTEXTLEN, index, 0)

    If sLen > 0 Then
      s = Space(sLen)
      SendMessageAsString List1.hWnd, LB_GETTEXT, index, s

      ' and calc its size
      hDC = GetDC(List1.hWnd)
      hFont = SendMessageAsLong(List1.hWnd, WM_GETFONT, 0, 0)
      hPrevFont = SelectObject(hDC, hFont)
      GetTextExtentPoint32 hDC, s, Len(s), sz
      SelectObject hDC, hPrevFont
      ReleaseDC List1.hWnd, hDC

      GetWindowRect List1.hWnd, rcWnd
      If Not (rcWnd.Right - rcWnd.Left < sz.cx) Then
        ' all fine, we're smaller than the listbox
        s = ""
      End If
    End If

    ' update tooltip
    ttToolTip.Text(List1.hWnd) = s
    If s = "" Then
      ttToolTip.Hide List1.hWnd
    Else
      ttToolTip.Show List1.hWnd
    End If
  End If

  iLastIndex = index
End Sub
